% Update rotation field by incremental rotation. 
% 
% function Rfield= update_rotation_field(Rfield, Incremental_rotation)
% 
function Rfield= update_rotation_field(Rfield, Incremental_rotation)
    Rs = get(Rfield,  'values'); 
    dA = get(Incremental_rotation, 'values'); 
    for i=1:size(Rs,1)
        R= reshape(Rs(i,:),3,3);
        Rs(i,:)= reshape(rotmat(dA(i,:))*R,1,9);
    end 
    Rfield=set(Rfield, 'values', Rs);
end

