function [Weak_axis_bending,Strong_axis_bending,Torsional]=FF_beam_analytical(E,nu,rho,Width,Height,Length)
    P=Beam_cross_section(struct( 'type','rectangle','d2',Height,'d3',Width) ) ;
    A=P.A;
    I2=P.I2;
    I3=P.I3;
    J=P.J;
   I1=P.I1;
    c2=sqrt(E*I2/A/rho);
    c3=sqrt(E*I3/A/rho);
    lam= 4.73004704;
    Weak_axis_bending=lam^2/2/pi/Length^2*c2;
    Strong_axis_bending=lam^2/2/pi/Length^2*c3;
    c1=sqrt(E/2/(1+nu)*J/I1/rho);
    Torsional=(1*pi)/2/pi/Length*c1;
end
