function [Es,nus,rhos,R,L]=F_circular_plate_data()
% Load physical unit definitions
    [uSEC,uMIN,uHR,uDAY,uWK,uMONTH,uYR,uFT,uSLUG,uRAN,...
        uM,uKG,uK,uCM,uGM,uDEG,uRAD,uREV,...
        uIN,uNMI,uYD,uMM,uMILE,uG,uLB,uNT,uOZ,uLBM,uKT,...
        uMPH,uPSI,uPA,uBAR,uATM,uTORR,ummHG,uJ,...
        uCAL,uMEV,uERG,uBTU,uW,uMW,uHP,uA,uV,...
        uHZ,uRPS,uRPM,uL,uGAL,uGPM,...
        uMICRO,uKILO,uMILLI,uMEGA,uGIGA,uTERA]=physical_units('si');
    Es= 72300*uMEGA*uPA;%Steel material parameters, [MPa]
    rhos= 2700*uKG*uM^-3;% Steel material parameters, [1000*kg/mm^3]
    nus=0.35;%Steel material parameters
     R=1.0*uM;% Meters implied
  L=0.1*uM;% Meters implied
end

