function [fens,gcells] =  Lframe_Mesh(L,w,t,nw,nL,nt)
        Nodes = [
            1    L-w,0,0
            2    L,0,0
            3     L, L,0
            4     L-w,L-w,0
            5     0,L,0
            6     0,L-w,0
            ];
        [fens1,gcells1] = Q4_quadrilateral(Nodes( [1, 2, 3, 4],2:4),nw,nL,struct('other_dimension',1));
        [fens2,gcells2] = Q4_quadrilateral(Nodes( [4,3,5,6],2:4),nw,nL,struct('other_dimension',1));
        [fens,g1,g2] = merge_meshes(fens1, gcells1, fens2, gcells2, 0.01);
        gcells= cat(g1,g2);
        [fens,gcells] = Q4_extrude(fens,gcells,nt,@(xyz, layer)([xyz(1:2), (t/nt)*(layer-1)]));
    end