function driven_cavity
    smult=0;
    stabfact=0.01;
    E=3;
    graphics= ~true;
    doeig=~true;
    W= 1; H= 1;

    nu =0.49999995;
    % nu =0.499;
    % nu =0.49;
    % nu =0.479;

    fx=gcf;
    % fx=figure;%

    % for n=[8,10,16, 24]
    for n=[10, 20,24,32]

        % [h,se]=doitt(smult,nu,stabfact, @feblock_defor_ss,1);

        %     figure(fx); plot (px,press,'mx:'); hold on, pause (1)
%         [px,press]=doitt(n, smult,nu,stabfact, @t3block2d,@feblock_defor_ss_nicer,simplex_nq_rule(struct('dim',2,'order',1)));
        %     figure(fx); plot (px,press,'kx:'); hold on, pause (1)

%         [px,press]=doitt(n, smult,nu,stabfact, @block2d,@feblock_defor_ss_nicer, tensprod_nq_rule(struct('dim',2,'order',1)));
%         [px,press]=doitt(n, smult,nu,stabfact, @block2d,@feblock_defor_ss_nicer, tensprod_nq_rule(struct('dim',2,'order',2)));
        % figure(fx); plot (px,press,'rx:'); hold on, pause (1)
        [px,press]=doitt(n, smult,nu,stabfact, @crosst3block,@feblock_defor_ss_nicer, simplex_nq_rule(struct('dim',2,'order',1)));
        figure(fx); plot (px,press,'gx:'); hold on, pause (1)

        % for i=0:1:5
        % global stabfact;
        %     stabfact =2 ^i-1;
        %     [px,press]=doitt(n, smult,nu,stabfact, @trianglet3block2d,@feblock_defor_ss_biax_avg_b_t3,1)
        %     figure(fx); plot (px,press,'ms-'); hold on, pause (1)
        % % end

        %     [px,press]=doitt(n, smult,nu,stabfact, @ct3block2d,@feblock_defor_ss_biax_avg_b_t3,1)
        %     figure(fx); plot (px,press,'ms-'); hold on, pause (1)

        %     [px,press]=doitt(n, smult,nu,stabfact, @block2d,@feblock_defor_ss_biax_sri,[1,2])
        %     figure(fx); plot (px,press,'bo-.'); hold on, pause (1)

    end


    function [px,press]=doitt(n,smult,nu,stabfact, mf,febf,integration_rule)
        disp(['Driven cavity: ' func2str(febf)]);
        % Parameters:

        % for n=[8,16,20]
        h=1/n;
        heps = 0*h/100;
        [fens,gcells] = mf(W,H, n, n, 1.0);

        dxy=h/10;
        sxy=smult*h/100;
        rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
        xy=get(fens,'xyz');
        for i=1:length(fens)
            if (xy(i,1)>dxy) & (xy(i,2)>dxy) & (xy(i,1)<W-dxy) & (xy(i,2)<H-dxy)
                xy(i,:)=[xy(i,1)+(2*rand(1)-1)/2*sxy,xy(i,2)+(2*rand(1)-1)/2*sxy];
            end
        end
        fens=set(fens,'xyz',xy);
        %         mesh{1}=fens;
        %         mesh{2}=gcells;
        %         drawmesh(mesh,'gcells'); view (2); pause
        % Material And finite element block
        propm = property_linel_iso(struct('E',E,'nu', nu));
        mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','strain'));
        feb = febf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',integration_rule,...
            'stabfact',stabfact));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero out
        % Apply EBC's
        % Now the rollers at the bottom
        ebc_fenids=fenode_select (fens,struct('box',[0,1,0, 0],'inflate',h/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        % Now the rollers at the sides
        ebc_fenids=fenode_select (fens,struct('box',[0, 0,0,1],'inflate',h/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[1,1,0,1],'inflate',h/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[heps,1-heps,1, 1],'inflate',h/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=1*ones(1,length (ebc_fenids));
        ebc_val=ebc_fenids*0+1;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[heps,1-heps,1, 1],'inflate',h/100));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=2*ones(1,length (ebc_fenids));
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        K = finish (K);
        % Load
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, nz_ebc_loads(feb, geom, u));
        F = finish(F);
        % Solve
        a = get(K,'mat');
        b = get(F,'vec');
        x = a\b;
        u = scatter_sysvec(u, x);

        B=E/3/(1-2*nu);
        fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
        c =fenode_select (fens,struct('box',[0,1,1/2, 1/2],'inflate',h/100));
        pressurex=B*gather (fld,c,'values');
        positionx=gather (geom,c,'values','noreshape');
        [ignore,ix]=sort(positionx(:,1));
        px=positionx(ix,1);
        press=pressurex(ix);

        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,struct ([]));
            scale=0.025;
            cmap = jet;
            nvals=get(fld,'values');%min(nvals),max(nvals)
            %     nvalsrange=[min(nvals),max(nvals)]
            nvalsrange=[-5/B,5/B];%[min(nvals),max(nvals)]
            %             nvalsrange=[-5e-3 5e-3];%[min(nvals),max(nvals)]
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
            %         draw(feb,gv, struct ('x', geom, 'u', +scale*u,'facecolor','none', 'shrink',1.0));
            % geom3d=combine (geom, 0*fld);
            % u3d=combine (u, 100000000*fld);
            % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,...
                'Position',[0.8 0.15 0.05 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String','Volumetric strain');
            %     show_field_as_arrows (gv,struct ('x', geom, 'u', 2*scale*u));
            view (2)
            pause(2); % next eigenvector
            %         for i=1:length(fens)
            %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
            %         end
            if doeig
                pause(2)
                %% Solve the eigenvibration problem
                neigvs = get(u,'neqns');
                [modes,Omega]=eig(full(a));
                [b,ix]=sort(diag(Omega));

                %% Display the first few eigenvibration modes
                mscale=1;
                w=clone(u,'w'); % make a copy of u
                for i=1:neigvs
                    disp(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                    w = scatter_sysvec(w, modes(:,ix(i)));
                    wv = get(w,'values');
                    % display the volumetric strain
                    scale=1;
                    cmap = gray;
                    fld = field_from_integration_points(feb, geom, w, [], 'vol_strain', 1);
                    nvals=get(fld,'values');%min(nvals),max(nvals)
                    nvalsrange=[-1e-7 1e-7];%[min(nvals),max(nvals)]
                    %             nvalsrange=[min(nvals),max(nvals)];
                    dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
                    colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
                    draw(feb,gv, struct ('x', geom, 'u', +scale*w,'colorfield',colorfield, 'shrink',1.0));
                    colormap(cmap);
                    cbh=colorbar;
                    set(cbh,...
                        'Position',[0.8 0.15 0.05 0.7],...
                        'YLim',[0,1],...
                        'YTick',[0,1],...
                        'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
                    set(get(cbh,'XLabel'),'String','Volumetric strain');
                    view (2); pause(3)
                    wmag = sqrt(wv(:,1).^2+wv(:,2).^2);
                    dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
                    colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',map_data(dcm, wmag)));
                    for scale=mscale*sin((0:1:42)/21*2*pi)
                        gv=reset (clear (gv),struct ('limits', [-1/40*W 41/40*W -1/40*H 5/4*H]));
                        %         headlight(gv);
                        draw(feb,gv, struct ('x', geom, 'u', scale*w,'colorfield',colorfield));
                        title(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                        pause(0.01);
                    end
                    title(['  Next eigenvector: type any key' ]);
                    clf;
                    pause(2); % next eigenvector
                end
            end
        end
    end

    function [fens,gcells]=truly_unstructured_mesh(Length,Width,nL,nW,thickness)
        v=[0, 0;1/2, 0;1, 0;1,1/2;1, 1;1/2, 1;0, 1;0,1/2];
        [fens,gcells]=triangle_mesh(v,min(Length/nL,Width/nW), thickness);
    end

    function [fens,gcells]=graded(Length,Width,nL,nW,thickness)
        h=1/n;
        % [fens,gcells] = targe2_mesh([0, 0; 1, 0; 1, 1; 0, 1], h, 1.0);
        % [fens,gcells] = targe2_mesh_gen({'curve 1 line 0 0 1 0',...
        %                                  'curve 2 line 1 0 1 1',...
        %                                  'curve 3 line 1 1 0 1',...
        %                                  'curve 4 line 0 1 0 0',...
        %                                  'subregion 1  property 1 boundary 1 2 3 4',...
        %                                  ['m-ctl-point constant ' num2str(h)],...
        % }, 1.0);
        [fens,gcells] = targe2_mesh_gen({'curve 1 line 0 0 1 0',...
            'curve 2 line 1 0 1 0.5',...
            'curve 3 line 1 0.5 0 0.5',...
            'curve 4 line 0 0.5 0 0',...
            'subregion 1  property 1 boundary 1 2 3 4',...
            'curve 5 line 1 0.5 1 1',...
            'curve 6 line 1 1 0 1',...
            'curve 7 line 0 1 0 0.5',...
            'subregion 2  property 1 boundary 5 6 7 -3',...
            ['m-ctl-point constant ' num2str(h)],...
            ['m-ctl-point 1 xy 0 1 near ' num2str(h/10) ' influence ' num2str(h/10)],...
            ['m-ctl-point 2 xy 1 1 near ' num2str(h/10) ' influence ' num2str(h/10)],...
            }, 1.0);
        % [fens,gcells] = targe2_mesh_gen({'curve 1 line 0 0 1 0',...
        %                                  'curve 2 line 1 0 1 0.5',...
        %                                  'curve 3 line 1 0.5 0 0.5',...
        %                                  'curve 4 line 0 0.5 0 0',...
        %                                  'subregion 1  property 1 boundary 1 2 3 4',...
        %                                  'curve 5 line 1 0.5 1 1',...
        %                                  'curve 6 line 1 1 0 1',...
        %                                  'curve 7 line 0 1 0 0.5',...
        %                                  'subregion 2  property 1 boundary 5 6 7 -3',...
        %                                  ['m-ctl-point constant ' num2str(h)],...
        % }, 1.0);
        % [fens,gcells] = targe2_mesh_gen({'curve 1 line 0 0 1 0',...
        %                                  'curve 2 line 1 0 1 1',...
        %                                  'curve 3 line 1 1 0 1',...
        %                                  'curve 4 line 0 1 0 0',...
        %                                  ['curve 5 line ' num2str(h) ' 0.5 ' num2str(1-h) ' 0.5'],...
        %                                  'subregion 1  property 1 boundary 1 2 3 4 5 -5',...
        %                                  ['m-ctl-point constant ' num2str(h)],...
        % }, 1.0);
    end
    return;
end