font='Times';
Legends = {};
Data = {};
Style = {};

uzex=-0.3024;


Data{end+1}=[
   2.0000e+000   2.0000e+001
  uzex uzex
]; Style{end+1}='k--'; Legends{end+1} ='Ref';



%T10: number of equations =1040
%     Normalized displacement =0.52199
%T10: number of equations =2280
%     Normalized displacement =0.81338
%T10: number of equations =4000
%     Normalized displacement =0.92175
Data{end+1}=[
    4.0000    6.0000    8.0000
   -0.1579   -0.2460   -0.2787

];Style{end+1}='kv--';Legends{end+1} ='T10';
%H27: number of equations =1040
%     Normalized displacement =0.81319
%H27: number of equations =2280
%     Normalized displacement =0.95165
%H27: number of equations =4000
%     Normalized displacement =0.98061
Data{end+1}=[
    4.0000    6.0000    8.0000
   -0.2459   -0.2878   -0.2965

];Style{end+1}='ks-';Legends{end+1} ='H27';
%NICE-H27: number of equations =1040
%     Normalized displacement =0.92849
%NICE-H27: number of equations =2280
%     Normalized displacement =0.98001
%NICE-H27: number of equations =4000
%     Normalized displacement =0.98999
Data{end+1}=[
    4.0000    6.0000    8.0000
   -0.2808   -0.2964   -0.2994

];Style{end+1}='mh-';Legends{end+1} ='NICE-H27';
%H20R: number of equations =592
%     Normalized displacement =0.99956
%H20R: number of equations =1284
%     Normalized displacement =0.99717
%H20R: number of equations =2240
%     Normalized displacement =0.99686
Data{end+1}=[
    4.0000    6.0000    8.0000
   -0.3023   -0.3015   -0.3014

];Style{end+1}='ro-';Legends{end+1} ='H20R';
%NICE-H20: number of equations =592
%     Normalized displacement =0.64945
%NICE-H20: number of equations =1284
%     Normalized displacement =0.89646
%NICE-H20: number of equations =2240
%     Normalized displacement =0.96108
Data{end+1}=[
    4.0000    6.0000    8.0000
   -0.1964   -0.2711   -0.2906

];Style{end+1}='mo--';Legends{end+1} ='NICE-H20';
%H20: number of equations =592
%     Normalized displacement =0.81159
%H20: number of equations =1284
%     Normalized displacement =0.95138
%H20: number of equations =2240
%     Normalized displacement =0.98049
Data{end+1}=[
    4.0000    6.0000    8.0000
   -0.2454   -0.2877   -0.2965

];Style{end+1}='k>--';Legends{end+1} ='H20';



for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=data(2,:);
%     plot(h,utip/uzex,Style{j},'lineWIDTH', 3); hold on;
    loglog(h,abs((utip-uzex)/uzex),Style{j},'lineWIDTH', 2); hold on;
end

set(gca,'XLim', [1, 10]);
% set(gca,'YLim', [1e-4, 1e-1]);
xlabel ('number of elements per side')
ylabel ('normalized displacement')
legend(Legends,'Location','Southwest')
set(gca,'Position',[0.15 0.15 0.5 0.5]);
set_label_defaults
hold on; grid on; figure (gcf);
% saveas(gcf,[mfilename '.png']);
 printeps(gcf,[mfilename '.eps']);
 close  all