% Compute Poisson ratio and Young's modulus from wave speed.
% 
% function [nu,E] = cscd2nuE(rho,cs,cd)
%  
function [nu,E] = cscd2nuE(rho,cs,cd)
    nu=(cd^2-2*cs^2)/2/(cd^2-cs^2);
    E =2*(1+nu)*rho*cs^2;
end