% 
%   Element matrix set class. This class provides means of storing
%   sets of element matrices (mass, stiffness), and transmitting them to
%   assembly by a sysmat object. Each set object represents the pair
%   of a cell array of matrices and a cell array (or arrays for unsymmetric matrices)
%   of equation numbers that can be assembled into the global
%   system matrix.
% 
%   @elematset/elematset - Constructor.
%   @elematset/placesymm - Should the matrix be assembled symmetrically?
%   @elematset/get -  Get attribute.
%   @elematset/set - Set an attribute.
