% Set property in the specified object.
%
% function retval = set(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function retval = set(self,varargin)
    if (nargin == 1)
        retval = {{{'matstates'}, {'material states for each gcell and each integration point'}};...
            } ;
        return;
    end
    prop_name=varargin{1};
    val=varargin{2};
    switch prop_name
        case 'matstates'
            self.matstates = val;
        otherwise
            self.feblock= set(self.feblock, varargin{:});
    end
    retval=self; % return self
end
