% integration_rule
%   This is a collection of classes implementing various
%   quadrature rules.
%
% -Simpson 1/3 rule
%   @simpson_1_3_rule/simpson_1_3_rule -  constructor
%   @simpson_1_3_rule/get - Get an attribute
% 
% -trapezoidal rule
%   @trapezoidal_rule/trapezoidal_rule -  constructor
%   @trapezoidal_rule/get - Get an attribute
% 
% -triangle quadrature rules
%   @tri_rule/tri_rule - Constructor
%   @tri_rule/get - Get an attribute
% 
% -Gaussian rules
%   @gauss_rule/gauss_rule - Constructor
%   @gauss_rule/get - Get an attribute
% 
% -hexahedron six-point rule
%   @hex_6pt_rule/hex_6pt_rule - Constructor
%   @hex_6pt_rule/get - Get an attribute
% 
% -tetrahedron quadrature rules
%   @tet_rule/tet_rule - Constructor
%   @tet_rule/get - Get an attribute
% 
% -integration at a point
%   @point_rule/point_rule - Constructor
%   @point_rule/get - Get an attribute
% 
% -Simpson nodal-quadrature rule
%   @simpson_nq_rule/simpson_nq_rule -  constructor
%   @simpson_nq_rule/get - Get an attribute
% 
% -simplex nodal-quadrature rule
%   @simplex_nq_rule/simplex_nq_rule -  constructor
%   @simplex_nq_rule/get - Get an attribute
% 
% -tensor-product nodal-quadrature rule
%   @tensprod_nq_rule/tensprod_nq_rule -  constructor
%   @tensprod_nq_rule/get - Get an attribute
