function Squash_a_cube
    E = 71240;
    %     [x,y]=solve ('400889.8-x/3/( 1-2*y)','80.194-x/2/(1+y)')
    nu= 0.49;
    nu= 0.495;
    nu= 0.;
    %     nu=.0;
    stabfact = 0*E;
    rho=5e-9;
    graphics = ~false;
    Cam =1.0e+003 * [  -1.4407   -0.8522    1.1901    0.1089    0.1350   -0.0492         0         0    0.0010    0.0062];
    scale=1;
    nw = 2;
    nL = 4;
    nt = 2;
    L=260;
    w=13;
    t=w/2;
    Fmag= 1/t/w;
    Pcritt =pi^2*E*(t^3*w/12)/(2*L)^2;
    Pcritw =pi^2*E*(t*w^3/12)/(2*L)^2;

    rand('state',0);% try to comment out this line and compare
    %                   results for several subsequent runs
    %
    function [fens,gcells] = h8T4(nw,nL)
        [fens,gcells]=t4block(w,t,L, nw,nt,nL);
    end
    function [fens,gcells] = h8T4d(nt)
        [fens,gcells]=t4blocka(1.0, 1.0, 1.0, nt(1),nt(2),nt(3));
        [fens1,gcells1]=t4blockb(1.0, 1.0, 1.0, nt(1),nt(2),nt(3));
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, 1/1000);
        gcells=cat(2,gcells1,gcells2);
    end
    function [fens,gcells] = h8H8(nw,nL)
       [fens,gcells]=block(w,t,L, nw,nt,nL);
    end
    function [fens,gcells] = h8H27(nw,nL)
        [fens,gcells]=block(w,t,L, nw,nt,nL);
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
    function [fens,gcells] = h8H20(nw,nL)
        [fens,gcells]=block(w,t,L, nw,nt,nL);
        [fens,gcells] = H8_to_H20(fens,gcells);
    end
    function [fens,gcells] = h8H64(nt)
        [fens,gcells]=block(1.0, 1.0, 1.0, nt(1),nt(2),nt(3));
        [fens,gcells] = H8_to_H64(fens,gcells);
    end

    eix=1;
    clear eltyd

    % eltyd(eix).label ='T4';
    % eltyd(eix).mf =@h8T4;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule= tet_rule(1);
    % eltyd(eix).surface_integration_rule=tri_rule(1);
    % eltyd(eix).styl='rv-.';
    % eix=eix+1;
    %
    % eltyd(eix).label ='H8';
    % eltyd(eix).mf =@h8H8;
    % eltyd(eix).blf =@feblock_defor_nonlinear;
    % eltyd(eix).integration_rule= gauss_rule (3,2);
    % eltyd(eix).surface_integration_rule=gauss_rule (2,2);
    % eltyd(eix).styl='rx-.';
    % eix=eix+1;

%         eltyd(eix).label ='NICE-H8';
%         eltyd(eix).mf =@h8H8;
%         eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%         eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
%         eltyd(eix).surface_integration_rule=tensprod_nq_rule(struct('dim',2,'order',1));
%         eltyd(eix).styl='rx-.';
%         eix=eix+1;

%         eltyd(eix).label ='NICE-T4';
%         eltyd(eix).mf =@h8T4;
%         eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%         eltyd(eix).integration_rule= simplex_nq_rule (3);
%         eltyd(eix).surface_integration_rule=tri_rule(1);
%         eltyd(eix).styl='m^-';
%         eix=eix+1;


    % eltyd(eix).label ='NICE-T4d';
    % eltyd(eix).mf =@h8T4d;
    % eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    % eltyd(eix).integration_rule= simplex_nq_doubled_rule (3);
    % eltyd(eix).surface_integration_rule=simplex_nq_doubled_rule (2);
    % eltyd(eix).styl='m^-';
    % eix=eix+1;

    eltyd(eix).label ='H27';
    eltyd(eix).mf =@h8H27;
    eltyd(eix).blf =@feblock_defor_nonlinear;
    eltyd(eix).integration_rule=gauss_rule (3,3);
    eltyd(eix).surface_integration_rule=gauss_rule(2, 3);
    eltyd(eix).styl='ks-';
    eix=eix+1;

%         eltyd(eix).label ='NICE-H27';
%         eltyd(eix).mf =@h8H27;
%         eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%         eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%         eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
%         eltyd(eix).styl='mh-';
%         eix=eix+1;

%     eltyd(eix).label ='H20R';
%     eltyd(eix).mf =@h8H20;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,3);
%     eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
%     eltyd(eix).styl='ro-';
%     eix=eix+1;
    %

    % eltyd(eix).label ='NICE-H64';
    % eltyd(eix).mf =@h8H64;
    % eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    % eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
    % eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',3));
    % eltyd(eix).styl='mh-';
    % eix=eix+1;

    function Compute
        %          Mesh
        [fens,gcells] = eltyd(eix).mf (nw, nL);
        %         [fens, gcells]=renum_mesh(fens, gcellsAnd, 'symrcm');
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        %     [fens, gcells]=renum_mesh_renumber(fens, gcells,...
        %         renum_mesh_numbering(fens,genconn(feb), 'symrcm'));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symamd'));
        bgcells =mesh_bdry(gcells, []);
        icl = gcell_select(fens, bgcells, struct('box', [-Inf,Inf,-Inf,Inf,L,L],'inflate',1/100));
        %          gv=drawmesh( {fens,gcells},'facecolor','none'); gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
        %         view(3); pause(1)
        % Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells(icl),...
            'integration_rule',eltyd(eix).surface_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).surface_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        %         Bottom surface
        ebc_fenids=fenode_select (fens,struct('box',[-Inf,Inf,-Inf,Inf,0,0],'inflate',1/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);

        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        u = u*0; % zero out the displacement


        feb1=feb;                                           % Make a copy of the state
        Load=zeros(3,1); Load(3) =-Fmag;
        fi=force_intensity(struct('magn',Load));
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        %         sum (get(F,'vec'))

        K = start (sparse_altassem_sysmat, get(u, 'neqns'));
        K = assemble (K, cat(2,...
            stiffness(feb1, geom, u,u),...
            stiffness_stab(feb1, geom, u,u,stabfact)));
        u = scatter_sysvec(u, K\F); % Displacement increment
        gv=graphic_viewer;
        gv=reset (gv,[]);
        draw(feb,gv, struct ('x', geom,'u',+1e3*u));
        draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));

        Kgeo = start (sparse_altassem_sysmat, get(u, 'neqns'));
        Kgeo = assemble (Kgeo, stiffness_geo(feb1, geom, u,0*u));

        neigvs = 10;
        options.tol =1e-206;
        options.maxit = 5000;
        options.disp = 0;
        [W,Omega]=eigs(-(get(Kgeo,'mat')+get(Kgeo,'mat')')/2,(get(K,'mat')+get(K,'mat')')/2,...
            neigvs,'lm', options);
        diag(Omega)
        [Omegas,ix]=sort(1./diag(Omega)) ;
        Omegas
        Omega= diag(Omegas);
        Smalleste = [min(find(Omegas>0))]
        % Plot
        scale=100;
        phi=clone(u,'phi'); % make a copy of u
        disp( ['Pcritt =' num2str(Pcritt) ', ' 'Pcritw =' num2str(Pcritw)])
        for i=Smalleste
            gv=graphic_viewer;
            gv=reset (gv,[]);
            %             norm(get(K,'mat')*W(:, ix(i))-Omega(i,i)*get(M,'mat')*W(:, ix(i)))
            disp(['  Eigenvector ' num2str(i) ' Critical load ' num2str(Omegas(i)) ]);
            %     clf;
            scale =L/3/max(abs(W(:,ix(i))));
            phi = scatter_sysvec(phi, W(:,ix(i)));
            wv = get(phi,'values');
            wmag = sqrt(wv(:,1).^2+wv(:,2).^2+wv(:,3).^2);
            dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
            colors=map_data(dcm, wmag);
            colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',colors));
            gv=reset (gv,[]);
            %                 set(gca,'FontSize',16)
            %     camset(gv,[-0.1591    0.0085   -0.3252    0.0001    0.0043    0.0013   -0.8985    0.0237    0.4383    5.4322]);
            draw(feb,gv, struct ('x', geom,'u',0*phi, 'facecolor','none'));
            draw(feb,gv, struct ('x', geom,'u',+scale*phi,'colorfield',colorfield));
            %     text(0,1.1*R,1.1*R,['\omega_' num2str(i) '=' num2str(sqrt(Omega(i,i))/2/pi) ],'FontSize',24);
            %     axis off
            %     saveas(gcf, ['drum_t4-' num2str(i) '.png'], 'png');
            %     pause(2); % next eigenvector
        end
    end

    for eix = 1:length(eltyd)
        Compute;
    end
end