try,avw_blank;catch,error('AVWTk is required; run AVWTk_init');end
dim=  [16,16,16];% dimensions in pixels
pixdim =5*[1, 1, 1];
mkoptions.dim= dim;
mkoptions.pixdim =pixdim;
mkoptions.fill_pixel =1;
mkoptions.name =mfilename;
avw= avw_blank(mkoptions);
mkoptions.R =norm(pixdim.*dim/2);
mkoptions.center = pixdim.*dim;
mkoptions.fill_pixel =2;
avw=avw_fill_sphere(avw,mkoptions);

[t,v,tmid] = voximg_to_T4(avw.img,[2]);
[dx, dy, dz]=avw_pixdim(avw);

v(:,1)=dx*v(:,1);v(:,2)=dy*v(:,2);v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
clear coarsening_options;
coarsening_options.stretch=1.25;
coarsening_options.desired_ts =mean([dx,dy,dz]);
f = t4util_bdry(t(find(tmid==2),:));
bv =zeros(size(v,1),1);
bv(f)=1;
coarsening_options.bv=bv;

disp( ['Mesh size: initial ' num2str(Initial_number)])

tic;
[t,v,tmid] = t4util_coarsen(t,v,tmid,coarsening_options);
Elapsed =toc;
disp( ['Elapsed time ' num2str(Elapsed)])

clear smoothing_options;
visfixed=0*ones(size(v,1),1);% 
smoothing_options.method='laplace';
smoothing_options.npass=12;
v=smooth_mesh(t,v,visfixed,smoothing_options);

disp( ['Mesh size: final ' num2str(size(t,1))])

fens =fenodeset(struct('id',(1:size(v,1))','xyz',v));
gcells =gcellset_T4(struct('conn',double(t)));
bg=mesh_bdry(gcells);
drawmesh({fens,bg},'gcells','facecolor','y');

write_stl ('sample',get(bg, 'conn'),v);