R= 1.2; L= 3.0;
[fens,gcells] = T4_cylinderdel(L,R, 2, 1);
bg=mesh_bdry(gcells);
gv=drawmesh({fens,bg},'gcells','facecolor','y')
axis on
labels('X', 'Y', 'Z')
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
show_field_as_markers(gv, struct('x',geom,'u',0*geom,'marker','o','markersize',4 ))
[fens,gcells] = T4_to_T10(fens,gcells);
bg=mesh_bdry(gcells);
l=[gcell_select(fens,bg,struct ('facing', true, 'direction', @(x)([0,x(2:3)]),'tolerance',eps))];
% gv =drawmesh({fens,subset(bg,l)},'gv',gv,'gcells','facecolor','y','facealpha',0.8);
axis on
labels('X', 'Y', 'Z')

xyz=get(fens, 'xyz' );
conn=get(subset(bg,l),'conn' );

for je=1:size(conn,1 )
    for jk=1:size(conn,2)
        x1=xyz(conn(je,jk),:);
        xyz(conn(je,jk),:)= [x1(1),x1(2)/norm(x1([2,3]))*R,x1(3)/norm(x1([2,3]))*R];
    end
end
fens=set(fens, 'xyz',xyz);
gv=drawmesh({fens,bg},'gcells','facecolor','g')
axis on
labels('X', 'Y', 'Z')
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
show_field_as_markers(gv, struct('x',geom,'u',0*geom,'marker','o','markersize',4 ))